/* -------------------------------------------------------------------------- */
/*                                 Interfaces                                 */
/* -------------------------------------------------------------------------- */

use std::collections::HashMap;

use super::util::Address;

pub struct AccessInfo {
    address: Address,
}

pub trait AccessGuard {
    fn check(&self, info: &AccessInfo);
}

pub enum AccessAction {
    Allow,
    Block,
}

/* -------------------------------------------------------------------------- */
/*                                Rate Limiting                               */
/* -------------------------------------------------------------------------- */

struct RateLimitAccessor {}

pub struct RateLimitAccessGuard {
    max_read: i32,
    max_write: i32,
    max_accessors: i32,
    accessors: HashMap<Address, RateLimitAccessor>,
}
